#[doc = "Register `PLD_MC_CFG_BYPASS` reader"]
pub struct R(crate::R<PLD_MC_CFG_BYPASS_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<PLD_MC_CFG_BYPASS_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<PLD_MC_CFG_BYPASS_SPEC>> for R {
    fn from(reader: crate::R<PLD_MC_CFG_BYPASS_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `PLD_MC_CFG_BYPASS` writer"]
pub struct W(crate::W<PLD_MC_CFG_BYPASS_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<PLD_MC_CFG_BYPASS_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<PLD_MC_CFG_BYPASS_SPEC>> for W {
    fn from(writer: crate::W<PLD_MC_CFG_BYPASS_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Bypass selection\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD0_MC0_BYPASS_A {
    #[doc = "0: No description available"]
    REGISTER = 0,
    #[doc = "1: No description available"]
    COMBINATIONAL = 1,
}
impl From<PLD0_MC0_BYPASS_A> for bool {
    #[inline(always)]
    fn from(variant: PLD0_MC0_BYPASS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD0_MC0_BYPASS` reader - Bypass selection"]
pub struct PLD0_MC0_BYPASS_R(crate::FieldReader<bool, PLD0_MC0_BYPASS_A>);
impl PLD0_MC0_BYPASS_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD0_MC0_BYPASS_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD0_MC0_BYPASS_A {
        match self.bits {
            false => PLD0_MC0_BYPASS_A::REGISTER,
            true => PLD0_MC0_BYPASS_A::COMBINATIONAL,
        }
    }
    #[doc = "Checks if the value of the field is `REGISTER`"]
    #[inline(always)]
    pub fn is_register(&self) -> bool {
        **self == PLD0_MC0_BYPASS_A::REGISTER
    }
    #[doc = "Checks if the value of the field is `COMBINATIONAL`"]
    #[inline(always)]
    pub fn is_combinational(&self) -> bool {
        **self == PLD0_MC0_BYPASS_A::COMBINATIONAL
    }
}
impl core::ops::Deref for PLD0_MC0_BYPASS_R {
    type Target = crate::FieldReader<bool, PLD0_MC0_BYPASS_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC0_BYPASS` writer - Bypass selection"]
pub struct PLD0_MC0_BYPASS_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD0_MC0_BYPASS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD0_MC0_BYPASS_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn register(self) -> &'a mut W {
        self.variant(PLD0_MC0_BYPASS_A::REGISTER)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn combinational(self) -> &'a mut W {
        self.variant(PLD0_MC0_BYPASS_A::COMBINATIONAL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | (value as u16 & 0x01);
        self.w
    }
}
#[doc = "Field `NC1` reader - Spare register bit"]
pub struct NC1_R(crate::FieldReader<bool, bool>);
impl NC1_R {
    pub(crate) fn new(bits: bool) -> Self {
        NC1_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for NC1_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `NC1` writer - Spare register bit"]
pub struct NC1_W<'a> {
    w: &'a mut W,
}
impl<'a> NC1_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | ((value as u16 & 0x01) << 1);
        self.w
    }
}
#[doc = "Bypass selection\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD0_MC1_BYPASS_A {
    #[doc = "0: No description available"]
    REGISTER = 0,
    #[doc = "1: No description available"]
    COMBINATIONAL = 1,
}
impl From<PLD0_MC1_BYPASS_A> for bool {
    #[inline(always)]
    fn from(variant: PLD0_MC1_BYPASS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD0_MC1_BYPASS` reader - Bypass selection"]
pub struct PLD0_MC1_BYPASS_R(crate::FieldReader<bool, PLD0_MC1_BYPASS_A>);
impl PLD0_MC1_BYPASS_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD0_MC1_BYPASS_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD0_MC1_BYPASS_A {
        match self.bits {
            false => PLD0_MC1_BYPASS_A::REGISTER,
            true => PLD0_MC1_BYPASS_A::COMBINATIONAL,
        }
    }
    #[doc = "Checks if the value of the field is `REGISTER`"]
    #[inline(always)]
    pub fn is_register(&self) -> bool {
        **self == PLD0_MC1_BYPASS_A::REGISTER
    }
    #[doc = "Checks if the value of the field is `COMBINATIONAL`"]
    #[inline(always)]
    pub fn is_combinational(&self) -> bool {
        **self == PLD0_MC1_BYPASS_A::COMBINATIONAL
    }
}
impl core::ops::Deref for PLD0_MC1_BYPASS_R {
    type Target = crate::FieldReader<bool, PLD0_MC1_BYPASS_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC1_BYPASS` writer - Bypass selection"]
pub struct PLD0_MC1_BYPASS_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD0_MC1_BYPASS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD0_MC1_BYPASS_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn register(self) -> &'a mut W {
        self.variant(PLD0_MC1_BYPASS_A::REGISTER)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn combinational(self) -> &'a mut W {
        self.variant(PLD0_MC1_BYPASS_A::COMBINATIONAL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | ((value as u16 & 0x01) << 2);
        self.w
    }
}
#[doc = "Field `NC3` reader - Spare register bit"]
pub struct NC3_R(crate::FieldReader<bool, bool>);
impl NC3_R {
    pub(crate) fn new(bits: bool) -> Self {
        NC3_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for NC3_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `NC3` writer - Spare register bit"]
pub struct NC3_W<'a> {
    w: &'a mut W,
}
impl<'a> NC3_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | ((value as u16 & 0x01) << 3);
        self.w
    }
}
#[doc = "Bypass selection\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD0_MC2_BYPASS_A {
    #[doc = "0: No description available"]
    REGISTER = 0,
    #[doc = "1: No description available"]
    COMBINATIONAL = 1,
}
impl From<PLD0_MC2_BYPASS_A> for bool {
    #[inline(always)]
    fn from(variant: PLD0_MC2_BYPASS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD0_MC2_BYPASS` reader - Bypass selection"]
pub struct PLD0_MC2_BYPASS_R(crate::FieldReader<bool, PLD0_MC2_BYPASS_A>);
impl PLD0_MC2_BYPASS_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD0_MC2_BYPASS_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD0_MC2_BYPASS_A {
        match self.bits {
            false => PLD0_MC2_BYPASS_A::REGISTER,
            true => PLD0_MC2_BYPASS_A::COMBINATIONAL,
        }
    }
    #[doc = "Checks if the value of the field is `REGISTER`"]
    #[inline(always)]
    pub fn is_register(&self) -> bool {
        **self == PLD0_MC2_BYPASS_A::REGISTER
    }
    #[doc = "Checks if the value of the field is `COMBINATIONAL`"]
    #[inline(always)]
    pub fn is_combinational(&self) -> bool {
        **self == PLD0_MC2_BYPASS_A::COMBINATIONAL
    }
}
impl core::ops::Deref for PLD0_MC2_BYPASS_R {
    type Target = crate::FieldReader<bool, PLD0_MC2_BYPASS_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC2_BYPASS` writer - Bypass selection"]
pub struct PLD0_MC2_BYPASS_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD0_MC2_BYPASS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD0_MC2_BYPASS_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn register(self) -> &'a mut W {
        self.variant(PLD0_MC2_BYPASS_A::REGISTER)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn combinational(self) -> &'a mut W {
        self.variant(PLD0_MC2_BYPASS_A::COMBINATIONAL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | ((value as u16 & 0x01) << 4);
        self.w
    }
}
#[doc = "Field `NC5` reader - Spare register bit"]
pub struct NC5_R(crate::FieldReader<bool, bool>);
impl NC5_R {
    pub(crate) fn new(bits: bool) -> Self {
        NC5_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for NC5_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `NC5` writer - Spare register bit"]
pub struct NC5_W<'a> {
    w: &'a mut W,
}
impl<'a> NC5_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | ((value as u16 & 0x01) << 5);
        self.w
    }
}
#[doc = "Bypass selection\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD0_MC3_BYPASS_A {
    #[doc = "0: No description available"]
    REGISTER = 0,
    #[doc = "1: No description available"]
    COMBINATIONAL = 1,
}
impl From<PLD0_MC3_BYPASS_A> for bool {
    #[inline(always)]
    fn from(variant: PLD0_MC3_BYPASS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD0_MC3_BYPASS` reader - Bypass selection"]
pub struct PLD0_MC3_BYPASS_R(crate::FieldReader<bool, PLD0_MC3_BYPASS_A>);
impl PLD0_MC3_BYPASS_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD0_MC3_BYPASS_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD0_MC3_BYPASS_A {
        match self.bits {
            false => PLD0_MC3_BYPASS_A::REGISTER,
            true => PLD0_MC3_BYPASS_A::COMBINATIONAL,
        }
    }
    #[doc = "Checks if the value of the field is `REGISTER`"]
    #[inline(always)]
    pub fn is_register(&self) -> bool {
        **self == PLD0_MC3_BYPASS_A::REGISTER
    }
    #[doc = "Checks if the value of the field is `COMBINATIONAL`"]
    #[inline(always)]
    pub fn is_combinational(&self) -> bool {
        **self == PLD0_MC3_BYPASS_A::COMBINATIONAL
    }
}
impl core::ops::Deref for PLD0_MC3_BYPASS_R {
    type Target = crate::FieldReader<bool, PLD0_MC3_BYPASS_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC3_BYPASS` writer - Bypass selection"]
pub struct PLD0_MC3_BYPASS_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD0_MC3_BYPASS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD0_MC3_BYPASS_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn register(self) -> &'a mut W {
        self.variant(PLD0_MC3_BYPASS_A::REGISTER)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn combinational(self) -> &'a mut W {
        self.variant(PLD0_MC3_BYPASS_A::COMBINATIONAL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | ((value as u16 & 0x01) << 6);
        self.w
    }
}
#[doc = "Field `NC7` reader - Spare register bit"]
pub struct NC7_R(crate::FieldReader<bool, bool>);
impl NC7_R {
    pub(crate) fn new(bits: bool) -> Self {
        NC7_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for NC7_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `NC7` writer - Spare register bit"]
pub struct NC7_W<'a> {
    w: &'a mut W,
}
impl<'a> NC7_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | ((value as u16 & 0x01) << 7);
        self.w
    }
}
#[doc = "Bypass selection\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD1_MC0_BYPASS_A {
    #[doc = "0: No description available"]
    REGISTER = 0,
    #[doc = "1: No description available"]
    COMBINATIONAL = 1,
}
impl From<PLD1_MC0_BYPASS_A> for bool {
    #[inline(always)]
    fn from(variant: PLD1_MC0_BYPASS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD1_MC0_BYPASS` reader - Bypass selection"]
pub struct PLD1_MC0_BYPASS_R(crate::FieldReader<bool, PLD1_MC0_BYPASS_A>);
impl PLD1_MC0_BYPASS_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD1_MC0_BYPASS_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD1_MC0_BYPASS_A {
        match self.bits {
            false => PLD1_MC0_BYPASS_A::REGISTER,
            true => PLD1_MC0_BYPASS_A::COMBINATIONAL,
        }
    }
    #[doc = "Checks if the value of the field is `REGISTER`"]
    #[inline(always)]
    pub fn is_register(&self) -> bool {
        **self == PLD1_MC0_BYPASS_A::REGISTER
    }
    #[doc = "Checks if the value of the field is `COMBINATIONAL`"]
    #[inline(always)]
    pub fn is_combinational(&self) -> bool {
        **self == PLD1_MC0_BYPASS_A::COMBINATIONAL
    }
}
impl core::ops::Deref for PLD1_MC0_BYPASS_R {
    type Target = crate::FieldReader<bool, PLD1_MC0_BYPASS_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC0_BYPASS` writer - Bypass selection"]
pub struct PLD1_MC0_BYPASS_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD1_MC0_BYPASS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD1_MC0_BYPASS_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn register(self) -> &'a mut W {
        self.variant(PLD1_MC0_BYPASS_A::REGISTER)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn combinational(self) -> &'a mut W {
        self.variant(PLD1_MC0_BYPASS_A::COMBINATIONAL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | ((value as u16 & 0x01) << 8);
        self.w
    }
}
#[doc = "Field `NC9` reader - Spare register bit"]
pub struct NC9_R(crate::FieldReader<bool, bool>);
impl NC9_R {
    pub(crate) fn new(bits: bool) -> Self {
        NC9_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for NC9_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `NC9` writer - Spare register bit"]
pub struct NC9_W<'a> {
    w: &'a mut W,
}
impl<'a> NC9_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 9)) | ((value as u16 & 0x01) << 9);
        self.w
    }
}
#[doc = "Bypass selection\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD1_MC1_BYPASS_A {
    #[doc = "0: No description available"]
    REGISTER = 0,
    #[doc = "1: No description available"]
    COMBINATIONAL = 1,
}
impl From<PLD1_MC1_BYPASS_A> for bool {
    #[inline(always)]
    fn from(variant: PLD1_MC1_BYPASS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD1_MC1_BYPASS` reader - Bypass selection"]
pub struct PLD1_MC1_BYPASS_R(crate::FieldReader<bool, PLD1_MC1_BYPASS_A>);
impl PLD1_MC1_BYPASS_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD1_MC1_BYPASS_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD1_MC1_BYPASS_A {
        match self.bits {
            false => PLD1_MC1_BYPASS_A::REGISTER,
            true => PLD1_MC1_BYPASS_A::COMBINATIONAL,
        }
    }
    #[doc = "Checks if the value of the field is `REGISTER`"]
    #[inline(always)]
    pub fn is_register(&self) -> bool {
        **self == PLD1_MC1_BYPASS_A::REGISTER
    }
    #[doc = "Checks if the value of the field is `COMBINATIONAL`"]
    #[inline(always)]
    pub fn is_combinational(&self) -> bool {
        **self == PLD1_MC1_BYPASS_A::COMBINATIONAL
    }
}
impl core::ops::Deref for PLD1_MC1_BYPASS_R {
    type Target = crate::FieldReader<bool, PLD1_MC1_BYPASS_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC1_BYPASS` writer - Bypass selection"]
pub struct PLD1_MC1_BYPASS_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD1_MC1_BYPASS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD1_MC1_BYPASS_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn register(self) -> &'a mut W {
        self.variant(PLD1_MC1_BYPASS_A::REGISTER)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn combinational(self) -> &'a mut W {
        self.variant(PLD1_MC1_BYPASS_A::COMBINATIONAL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 10)) | ((value as u16 & 0x01) << 10);
        self.w
    }
}
#[doc = "Field `NC11` reader - Spare register bit"]
pub struct NC11_R(crate::FieldReader<bool, bool>);
impl NC11_R {
    pub(crate) fn new(bits: bool) -> Self {
        NC11_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for NC11_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `NC11` writer - Spare register bit"]
pub struct NC11_W<'a> {
    w: &'a mut W,
}
impl<'a> NC11_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | ((value as u16 & 0x01) << 11);
        self.w
    }
}
#[doc = "Bypass selection\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD1_MC2_BYPASS_A {
    #[doc = "0: No description available"]
    REGISTER = 0,
    #[doc = "1: No description available"]
    COMBINATIONAL = 1,
}
impl From<PLD1_MC2_BYPASS_A> for bool {
    #[inline(always)]
    fn from(variant: PLD1_MC2_BYPASS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD1_MC2_BYPASS` reader - Bypass selection"]
pub struct PLD1_MC2_BYPASS_R(crate::FieldReader<bool, PLD1_MC2_BYPASS_A>);
impl PLD1_MC2_BYPASS_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD1_MC2_BYPASS_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD1_MC2_BYPASS_A {
        match self.bits {
            false => PLD1_MC2_BYPASS_A::REGISTER,
            true => PLD1_MC2_BYPASS_A::COMBINATIONAL,
        }
    }
    #[doc = "Checks if the value of the field is `REGISTER`"]
    #[inline(always)]
    pub fn is_register(&self) -> bool {
        **self == PLD1_MC2_BYPASS_A::REGISTER
    }
    #[doc = "Checks if the value of the field is `COMBINATIONAL`"]
    #[inline(always)]
    pub fn is_combinational(&self) -> bool {
        **self == PLD1_MC2_BYPASS_A::COMBINATIONAL
    }
}
impl core::ops::Deref for PLD1_MC2_BYPASS_R {
    type Target = crate::FieldReader<bool, PLD1_MC2_BYPASS_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC2_BYPASS` writer - Bypass selection"]
pub struct PLD1_MC2_BYPASS_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD1_MC2_BYPASS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD1_MC2_BYPASS_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn register(self) -> &'a mut W {
        self.variant(PLD1_MC2_BYPASS_A::REGISTER)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn combinational(self) -> &'a mut W {
        self.variant(PLD1_MC2_BYPASS_A::COMBINATIONAL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 12)) | ((value as u16 & 0x01) << 12);
        self.w
    }
}
#[doc = "Field `NC13` reader - Spare register bit"]
pub struct NC13_R(crate::FieldReader<bool, bool>);
impl NC13_R {
    pub(crate) fn new(bits: bool) -> Self {
        NC13_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for NC13_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `NC13` writer - Spare register bit"]
pub struct NC13_W<'a> {
    w: &'a mut W,
}
impl<'a> NC13_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 13)) | ((value as u16 & 0x01) << 13);
        self.w
    }
}
#[doc = "Bypass selection\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD1_MC3_BYPASS_A {
    #[doc = "0: No description available"]
    REGISTER = 0,
    #[doc = "1: No description available"]
    COMBINATIONAL = 1,
}
impl From<PLD1_MC3_BYPASS_A> for bool {
    #[inline(always)]
    fn from(variant: PLD1_MC3_BYPASS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD1_MC3_BYPASS` reader - Bypass selection"]
pub struct PLD1_MC3_BYPASS_R(crate::FieldReader<bool, PLD1_MC3_BYPASS_A>);
impl PLD1_MC3_BYPASS_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD1_MC3_BYPASS_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD1_MC3_BYPASS_A {
        match self.bits {
            false => PLD1_MC3_BYPASS_A::REGISTER,
            true => PLD1_MC3_BYPASS_A::COMBINATIONAL,
        }
    }
    #[doc = "Checks if the value of the field is `REGISTER`"]
    #[inline(always)]
    pub fn is_register(&self) -> bool {
        **self == PLD1_MC3_BYPASS_A::REGISTER
    }
    #[doc = "Checks if the value of the field is `COMBINATIONAL`"]
    #[inline(always)]
    pub fn is_combinational(&self) -> bool {
        **self == PLD1_MC3_BYPASS_A::COMBINATIONAL
    }
}
impl core::ops::Deref for PLD1_MC3_BYPASS_R {
    type Target = crate::FieldReader<bool, PLD1_MC3_BYPASS_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC3_BYPASS` writer - Bypass selection"]
pub struct PLD1_MC3_BYPASS_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD1_MC3_BYPASS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD1_MC3_BYPASS_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn register(self) -> &'a mut W {
        self.variant(PLD1_MC3_BYPASS_A::REGISTER)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn combinational(self) -> &'a mut W {
        self.variant(PLD1_MC3_BYPASS_A::COMBINATIONAL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 14)) | ((value as u16 & 0x01) << 14);
        self.w
    }
}
#[doc = "Field `NC15` reader - Spare register bit"]
pub struct NC15_R(crate::FieldReader<bool, bool>);
impl NC15_R {
    pub(crate) fn new(bits: bool) -> Self {
        NC15_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for NC15_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `NC15` writer - Spare register bit"]
pub struct NC15_W<'a> {
    w: &'a mut W,
}
impl<'a> NC15_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 15)) | ((value as u16 & 0x01) << 15);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Bypass selection"]
    #[inline(always)]
    pub fn pld0_mc0_bypass(&self) -> PLD0_MC0_BYPASS_R {
        PLD0_MC0_BYPASS_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Spare register bit"]
    #[inline(always)]
    pub fn nc1(&self) -> NC1_R {
        NC1_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Bypass selection"]
    #[inline(always)]
    pub fn pld0_mc1_bypass(&self) -> PLD0_MC1_BYPASS_R {
        PLD0_MC1_BYPASS_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Spare register bit"]
    #[inline(always)]
    pub fn nc3(&self) -> NC3_R {
        NC3_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Bypass selection"]
    #[inline(always)]
    pub fn pld0_mc2_bypass(&self) -> PLD0_MC2_BYPASS_R {
        PLD0_MC2_BYPASS_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Spare register bit"]
    #[inline(always)]
    pub fn nc5(&self) -> NC5_R {
        NC5_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Bypass selection"]
    #[inline(always)]
    pub fn pld0_mc3_bypass(&self) -> PLD0_MC3_BYPASS_R {
        PLD0_MC3_BYPASS_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Spare register bit"]
    #[inline(always)]
    pub fn nc7(&self) -> NC7_R {
        NC7_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Bypass selection"]
    #[inline(always)]
    pub fn pld1_mc0_bypass(&self) -> PLD1_MC0_BYPASS_R {
        PLD1_MC0_BYPASS_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - Spare register bit"]
    #[inline(always)]
    pub fn nc9(&self) -> NC9_R {
        NC9_R::new(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 10 - Bypass selection"]
    #[inline(always)]
    pub fn pld1_mc1_bypass(&self) -> PLD1_MC1_BYPASS_R {
        PLD1_MC1_BYPASS_R::new(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - Spare register bit"]
    #[inline(always)]
    pub fn nc11(&self) -> NC11_R {
        NC11_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 12 - Bypass selection"]
    #[inline(always)]
    pub fn pld1_mc2_bypass(&self) -> PLD1_MC2_BYPASS_R {
        PLD1_MC2_BYPASS_R::new(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 13 - Spare register bit"]
    #[inline(always)]
    pub fn nc13(&self) -> NC13_R {
        NC13_R::new(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 14 - Bypass selection"]
    #[inline(always)]
    pub fn pld1_mc3_bypass(&self) -> PLD1_MC3_BYPASS_R {
        PLD1_MC3_BYPASS_R::new(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 15 - Spare register bit"]
    #[inline(always)]
    pub fn nc15(&self) -> NC15_R {
        NC15_R::new(((self.bits >> 15) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Bypass selection"]
    #[inline(always)]
    pub fn pld0_mc0_bypass(&mut self) -> PLD0_MC0_BYPASS_W {
        PLD0_MC0_BYPASS_W { w: self }
    }
    #[doc = "Bit 1 - Spare register bit"]
    #[inline(always)]
    pub fn nc1(&mut self) -> NC1_W {
        NC1_W { w: self }
    }
    #[doc = "Bit 2 - Bypass selection"]
    #[inline(always)]
    pub fn pld0_mc1_bypass(&mut self) -> PLD0_MC1_BYPASS_W {
        PLD0_MC1_BYPASS_W { w: self }
    }
    #[doc = "Bit 3 - Spare register bit"]
    #[inline(always)]
    pub fn nc3(&mut self) -> NC3_W {
        NC3_W { w: self }
    }
    #[doc = "Bit 4 - Bypass selection"]
    #[inline(always)]
    pub fn pld0_mc2_bypass(&mut self) -> PLD0_MC2_BYPASS_W {
        PLD0_MC2_BYPASS_W { w: self }
    }
    #[doc = "Bit 5 - Spare register bit"]
    #[inline(always)]
    pub fn nc5(&mut self) -> NC5_W {
        NC5_W { w: self }
    }
    #[doc = "Bit 6 - Bypass selection"]
    #[inline(always)]
    pub fn pld0_mc3_bypass(&mut self) -> PLD0_MC3_BYPASS_W {
        PLD0_MC3_BYPASS_W { w: self }
    }
    #[doc = "Bit 7 - Spare register bit"]
    #[inline(always)]
    pub fn nc7(&mut self) -> NC7_W {
        NC7_W { w: self }
    }
    #[doc = "Bit 8 - Bypass selection"]
    #[inline(always)]
    pub fn pld1_mc0_bypass(&mut self) -> PLD1_MC0_BYPASS_W {
        PLD1_MC0_BYPASS_W { w: self }
    }
    #[doc = "Bit 9 - Spare register bit"]
    #[inline(always)]
    pub fn nc9(&mut self) -> NC9_W {
        NC9_W { w: self }
    }
    #[doc = "Bit 10 - Bypass selection"]
    #[inline(always)]
    pub fn pld1_mc1_bypass(&mut self) -> PLD1_MC1_BYPASS_W {
        PLD1_MC1_BYPASS_W { w: self }
    }
    #[doc = "Bit 11 - Spare register bit"]
    #[inline(always)]
    pub fn nc11(&mut self) -> NC11_W {
        NC11_W { w: self }
    }
    #[doc = "Bit 12 - Bypass selection"]
    #[inline(always)]
    pub fn pld1_mc2_bypass(&mut self) -> PLD1_MC2_BYPASS_W {
        PLD1_MC2_BYPASS_W { w: self }
    }
    #[doc = "Bit 13 - Spare register bit"]
    #[inline(always)]
    pub fn nc13(&mut self) -> NC13_W {
        NC13_W { w: self }
    }
    #[doc = "Bit 14 - Bypass selection"]
    #[inline(always)]
    pub fn pld1_mc3_bypass(&mut self) -> PLD1_MC3_BYPASS_W {
        PLD1_MC3_BYPASS_W { w: self }
    }
    #[doc = "Bit 15 - Spare register bit"]
    #[inline(always)]
    pub fn nc15(&mut self) -> NC15_W {
        NC15_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "PLD Macro cell Bypass control\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pld_mc_cfg_bypass](index.html) module"]
pub struct PLD_MC_CFG_BYPASS_SPEC;
impl crate::RegisterSpec for PLD_MC_CFG_BYPASS_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [pld_mc_cfg_bypass::R](R) reader structure"]
impl crate::Readable for PLD_MC_CFG_BYPASS_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [pld_mc_cfg_bypass::W](W) writer structure"]
impl crate::Writable for PLD_MC_CFG_BYPASS_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets PLD_MC_CFG_BYPASS to value 0"]
impl crate::Resettable for PLD_MC_CFG_BYPASS_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
